LeetCode Problem 2:Two Sum

描述:less

Given an array of integers, find two numbers such that they add up to a specific target number.spa

The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2. Please note that your returned answers (both index1 and index2) are not zero-based.code

You may assume that each input would have exactly one solution.blog

Input: numbers={2, 7, 11, 15}, target=9
Output: index1=1, index2=2 ci

思路1:暴力搜索,兩層循環。時間:O(n^2),空間:O(1),可能出現超時get

思路2:考慮使用map或者hash_map,遍歷輸入的numbers,在map映射表中尋找target-numbers[i],C++ STL中map使用紅黑樹實現,查找元素時間O(logn),總時間O(nlogn)input

 1 class Solution {
 2 public:
 3     vector<int> twoSum(vector<int> &numbers, int target) {
 4         
 5         vector<int> result;
 6         map<int, int> hashMap;
 7         
 8         for(int i = 0; i < numbers.size(); i++) {
 9             
10             if(!hashMap.count(numbers[i])) 
11                 hashMap.insert(pair<int,int>(numbers[i], i));   // <value, key>
12                 
13             if(hashMap.count(target - numbers[i]))  {
14                 int n = hashMap[target - numbers[i]];   //get the second number's position
15                 if(n < i)   {
16                     result.push_back(n + 1);
17                     result.push_back(i + 1);
18                     return result;
19                 }
20                 
21                 //unnecessary
22                 /*if(n > i)    {
23                     result.push_back(i + 1);
24                     result.push_back(n + 1);
25                     return result;
26                 }*/
27             }
28         }
29     }
30 };

 

附LeetCode建議解決方案hash

相關文章
相關標籤/搜索